function S = myspecgram(filename,dt,df)
% ===   ===
%
%  :
% filename -   
% dt -   
% df -   
%  :
% S - 
%
% ===    ===
[x, fs] = wavread(filename);
%
% ===      ===
nfft = round(fs/df);        %   =   =  
shft = round(dt*fs);               %  ,   - 
nfrm = floor((length(x)-nfft)/shft); %  
%
% ===  x(n)   ===
xfrm = zeros(nfft,nfrm);  %  
for k = 1:nfrm
    nach = 1+(k-1)*shft; kon = nach+nfft-1;   %   
    xfrm(:,k) = x(nach:kon);                  %  
end
%
% ===     ===
w = hamming(nfft);
winmatr = repmat(w,1,nfrm);
xwin = winmatr.*xfrm;
%
% ===     ===
sp = fft(xwin);
S1 = sp.*conj(sp);
%
% ===   ,    .  . ===
S1 = S1(1:round(nfft/2),:);
Sabs = abs(S1);
Samax = max(max(Sabs));
S2 = Sabs/Samax;
S = im2uint16(S2);
%
% ===   ===
tx = 0:1/fs:(length(x)-1)/fs;
figure; subplot(2,1,1); plot(tx,x);
xlabel(', '); ylabel('');

t = 0:dt:(size(S,2)-1)*dt;
f = 0:df:(size(S,1)-1)*df;
subplot(2,1,2); image(t,f,S);
xlabel(', '); ylabel(', ');

